<template lang="html">
  <div class="feedback-dialog">
    <div class="content">
      <div v-if="profile.isFeedbackSubmitted"
        class="feedback-sent-container">
        <h1>Thanks for your feedback!</h1>
        <h3>You are helping us improve Enoplay :)</h3>
      </div>
      <form v-else-if="!profile.isFeedbackSubmitted"
        v-on:submit="submitForm($event)">
        <div class="cancelBtn-container">
          <button class="cancelBtn linkBtn" v-on:click="closeDialog()">{{ label.CANCEL }}</button>
        </div>
        <label for="name">{{ label.NAME }}</label>
        <input id="name"
          type="text"
          v-model.trim="form.name"
          :placeholder="label.NAME_PLACEHOLDER">
        <div v-if="form.isSubmitted && $v.form.name.$invalid" class="error">
          <span v-if="!$v.form.name.required">Your Name is required.</span>
        </div>
        <label for="email">{{ label.EMAIL }}</label>
        <input id="email"
          type="text"
          v-model.trim="form.email"
          :placeholder="label.EMAIL_PLACEHOLDER">
        <div v-if="form.isSubmitted && $v.form.email.$invalid" class="error">
          <span v-if="!$v.form.email.required">Your Email is required.</span>
          <span v-if="!$v.form.email.email">Invalid email.</span>
        </div>
        <label for="message">{{ label.MESSAGE }}</label>
        <textarea id="message"
          v-model.trim="form.message"
          rows="5"></textarea>
        <div v-if="form.isSubmitted && $v.form.message.$invalid" class="error">
          <span v-if="!$v.form.message.required">Your Feedback is required.</span>
        </div>
        <input type="submit" :value="label.SUBMIT">
      </form>
      <div v-if="showFormSpinner"
        class="spinner">
        <ep-spinner class="spinner-icon"></ep-spinner>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import { required, email } from 'vuelidate/lib/validators'

import Spinner from '../Spinner'

export default {
  name: 'ep-feedback-view',
  components: {
    'ep-spinner': Spinner
  },
  data () {
    return {
      form: {
        name: '',
        email: '',
        message: '',
        isSubmitted: false
      },
      label: {
        NAME_PLACEHOLDER: 'Your Name',
        EMAIL_PLACEHOLDER: 'me@place.com',
        MESSAGE_PLACEHOLDER: '',
        NAME: 'Name',
        EMAIL: 'Email',
        MESSAGE: 'Your Feedback',
        SUBMIT: 'Send Feedback',
        CANCEL: 'Cancel'
      },
      showFormSpinner: false
    }
  },
  validations: {
    form: {
      name: {
        required
      },
      email: {
        required,
        email
      },
      message: {
        required
      }
    }
  },
  computed: {
    ...mapGetters([
      'profile'
    ])
  },
  mounted () {
    this.form.name = this.profile.alias
    this.form.email = this.profile.email
  },
  methods: {
    ...mapActions('app', [
      'closeDialog'
    ]),
    submitForm (event) {
      event.preventDefault()

      this.form.isSubmitted = true

      // Validate Input
      if (this.$v.form.$invalid) {
        return
      }

      this.showFormSpinner = true
      this.$store.dispatch('sendFeedback', {
        name: this.form.name,
        email: this.form.email,
        message: this.form.message
      })
      .then(() => {
        this.showFormSpinner = false
      })
      .catch(() => { /* Do nothing for now */ })
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/theme';
@import '~assets/styles/input';

.feedback-dialog {
  position: relative;
  display: block;
  background: #FFFFFF;
  width: $dialog-width;
  overflow: hidden;
}

.content {
  position: relative;
  padding: 40px 20px;
  margin: auto;
  text-align: left;
}

.error {
  margin-bottom: 20px;
  color: #cc0000;
}

.feedback-sent-container {
  color: $text-color;
  text-align: center;
}

.spinner {
  position: relative;
}

.cancelBtn-container {
  margin-bottom: 20px;
  width: 100%;
  text-align: right;
}

.linkBtn {
  background: none!important;
  border: none;
  padding: 0!important;
  font: inherit;
  color: $form-primary-color;
  cursor: pointer;
}

#message {
  resize: none;
}
</style>
